wxWidgets: wxListEvent Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxListEvent Class Reference
Events

`#include <wx/listctrl.h>`

Inheritance diagram for wxListEvent:
[legend]

## Detailed Description

A list event holds information about events associated with wxListCtrl objects.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxListEvent& event)

Event macros:

- EVT_LIST_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button.
- EVT_LIST_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button.
- EVT_LIST_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto().
- EVT_LIST_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto().
- EVT_LIST_DELETE_ITEM(id, func):
  Delete an item.
- EVT_LIST_DELETE_ALL_ITEMS(id, func):
  Delete all items.
- EVT_LIST_ITEM_SELECTED(id, func):
  The item has been selected.
- EVT_LIST_ITEM_DESELECTED(id, func):
  The item has been deselected.
- EVT_LIST_ITEM_ACTIVATED(id, func):
  The item has been activated (ENTER or double click).
- EVT_LIST_ITEM_FOCUSED(id, func):
  The currently focused item has changed.
- EVT_LIST_ITEM_MIDDLE_CLICK(id, func):
  The middle mouse button has been clicked on an item.
- EVT_LIST_ITEM_RIGHT_CLICK(id, func):
  The right mouse button has been clicked on an item.
- EVT_LIST_KEY_DOWN(id, func):
  A key has been pressed. GetIndex() may be -1 if no item is selected.
- EVT_LIST_INSERT_ITEM(id, func):
  An item has been inserted.
- EVT_LIST_COL_CLICK(id, func):
  A column (m_col) has been left-clicked.
- EVT_LIST_COL_RIGHT_CLICK(id, func):
  A column (m_col) (which can be -1 if the click occurred outside any column) has been right-clicked.
- EVT_LIST_COL_BEGIN_DRAG(id, func):
  The user started resizing a column - can be vetoed.
- EVT_LIST_COL_DRAGGING(id, func):
  The divider between columns is being dragged.
- EVT_LIST_COL_END_DRAG(id, func):
  A column has been resized by the user.
- EVT_LIST_CACHE_HINT(id, func):
  Prepare cache for a virtual list control

##

Library: wxCore
Category: Events

See Also
  wxListCtrl

## Public Member Functions
| wxListEvent (wxEventType commandType=wxEVT_NULL, int id=0)
| Constructor.
long | GetCacheFrom () const
| For `EVT_LIST_CACHE_HINT` event only: return the first item which the list control advises us to cache.
long | GetCacheTo () const
| For `EVT_LIST_CACHE_HINT` event only: return the last item (inclusive) which the list control advises us to cache.
int | GetColumn () const
| The column position: it is only used with `COL` events.
wxUIntPtr | GetData () const
| The data.
int | GetImage () const
| The image.
long | GetIndex () const
| The item index.
const wxListItem & | GetItem () const
| An item object, used by some events.
int | GetKeyCode () const
| Key code if the event is a keypress event.
const wxString & | GetLabel () const
| The (new) item label for `EVT_LIST_END_LABEL_EDIT` event.
long | GetMask () const
| The mask.
wxPoint | GetPoint () const
| The position of the mouse pointer if the event is a drag event.
const wxString & | GetText () const
| The text.
bool | IsEditCancelled () const
| This method only makes sense for `EVT_LIST_END_LABEL_EDIT` message and returns true if it the label editing has been cancelled by the user (GetLabel() returns an empty string in this case but it doesn't allow the application to distinguish between really cancelling the edit and the admittedly rare case when the user wants to rename it to an empty string).
Public Member Functions inherited from wxNotifyEvent
| wxNotifyEvent (wxEventType eventType=wxEVT_NULL, int id=0)
| Constructor (used internally by wxWidgets only).
void | Allow ()
| This is the opposite of Veto(): it explicitly allows the event to be processed.
bool | IsAllowed () const
| Returns true if the change is allowed (Veto() hasn't been called) or false otherwise (if it was).
void | Veto ()
| Prevents the change announced by this event from happening.
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor.
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection).
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection).
long | GetExtraLong () const
| Returns extra information dependent on the event objects type.
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox.
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection).
wxString | GetString () const
| Returns item string for a listbox or choice selection event.
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one.
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection.
void | SetClientData (void *clientData)
| Sets the client data for this event.
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event.
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member.
void | SetInt (int intCommand)
| Sets the m_commandInt member.
void | SetString (const wxString &string)
| Sets the m_commandString member.
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate.

## Constructor & Destructor Documentation

wxListEvent::wxListEvent | ( | wxEventType | commandType = `wxEVT_NULL`,
|  | int | id = `0`
| ) |  |

Constructor.

## Member Function Documentation

long wxListEvent::GetCacheFrom | ( |  | ) | const

For `EVT_LIST_CACHE_HINT` event only: return the first item which the list control advises us to cache.

long wxListEvent::GetCacheTo | ( |  | ) | const

For `EVT_LIST_CACHE_HINT` event only: return the last item (inclusive) which the list control advises us to cache.

int wxListEvent::GetColumn | ( |  | ) | const

The column position: it is only used with `COL` events.

For the column dragging events, it is the column to the left of the divider being dragged, for the column click events it may be -1 if the user clicked in the list control header outside any column.

wxUIntPtr wxListEvent::GetData | ( |  | ) | const

The data.

int wxListEvent::GetImage | ( |  | ) | const

The image.

long wxListEvent::GetIndex | ( |  | ) | const

The item index.

const wxListItem& wxListEvent::GetItem | ( |  | ) | const

An item object, used by some events.

See also wxListCtrl::SetItem.

int wxListEvent::GetKeyCode | ( |  | ) | const

Key code if the event is a keypress event.

const wxString& wxListEvent::GetLabel | ( |  | ) | const

The (new) item label for `EVT_LIST_END_LABEL_EDIT` event.

long wxListEvent::GetMask | ( |  | ) | const

The mask.

wxPoint wxListEvent::GetPoint | ( |  | ) | const

The position of the mouse pointer if the event is a drag event.

const wxString& wxListEvent::GetText | ( |  | ) | const

The text.

bool wxListEvent::IsEditCancelled | ( |  | ) | const

This method only makes sense for `EVT_LIST_END_LABEL_EDIT` message and returns true if it the label editing has been cancelled by the user (GetLabel() returns an empty string in this case but it doesn't allow the application to distinguish between really cancelling the edit and the admittedly rare case when the user wants to rename it to an empty string).